<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>JSON-LD &mdash; Heiwa  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Enums" href="heiwa.enums.html" />
    <link rel="prev" title="Utilities" href="heiwa.database.utils.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> Heiwa
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="performance.html">Performance</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="heiwa.html">API Documentation</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="heiwa.html#subpackages">Subpackages</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="heiwa.authentication.html">Authentication</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.constants.html">Statuses</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.database.html">Database</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">JSON-LD</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.enums.html">Enums</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.error_handlers.html">Error handlers</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.exceptions.html">Exceptions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.limiter.html">Rate limiter</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.tasks.html">Tasks</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.types.html">Abstract types</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.validators.html">Validators</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.html">API views</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.html#module-heiwa">Root</a></li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">Heiwa</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="heiwa.html">API Documentation</a> &raquo;</li>
      <li>JSON-LD</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/heiwa.json_ld.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="module-heiwa.json_ld">
<span id="json-ld"></span><h1>JSON-LD<a class="headerlink" href="#module-heiwa.json_ld" title="Permalink to this headline"></a></h1>
<p>JSON-LD encoding.</p>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference external" href="https://json-ld.org/">JSON for linking data - json-ld.org</a></p>
</div>
<dl class="py class">
<dt class="sig sig-object py" id="heiwa.json_ld.JSONLDEncoder">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">heiwa.json_ld.</span></span><span class="sig-name descname"><span class="pre">JSONLDEncoder</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">*</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">skipkeys</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ensure_ascii</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">check_circular</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">allow_nan</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">sort_keys</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">indent</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">separators</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">default</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa/json_ld.html#JSONLDEncoder"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.json_ld.JSONLDEncoder" title="Permalink to this definition"></a></dt>
<dd><p>A JSON encoder based on the default
<code class="xref py py-class docutils literal notranslate"><span class="pre">JSONEncoder</span></code>, with support for JSON-LD SQLAlchemy
ORM objects.</p>
<p>SQLAlchemy ORM model instances are converted to dictionaries containing all
columns allowed for the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> (if there is one), or
don’t start with <code class="docutils literal notranslate"><span class="pre">_</span></code> if there are no permissions set up. A <code class="docutils literal notranslate"><span class="pre">&#64;context</span></code>
key is added based on the <code class="docutils literal notranslate"><span class="pre">JSON_LD_CONTEXT_URL</span></code>, as well as <code class="docutils literal notranslate"><span class="pre">&#64;type</span></code>, which
is based on their class’ names. If the instance has a <code class="docutils literal notranslate"><span class="pre">get_id_url</span></code>
method and there is a Flask request context, an <code class="docutils literal notranslate"><span class="pre">&#64;id</span></code> is added with the
result of the method being run.</p>
<p><code class="xref py py-class docutils literal notranslate"><span class="pre">bytes</span></code> are converted to their base64-encoded string equivalents.</p>
<p><code class="xref py py-class docutils literal notranslate"><span class="pre">date</span></code>s, <code class="xref py py-class docutils literal notranslate"><span class="pre">time</span></code>s and
<code class="xref py py-class docutils literal notranslate"><span class="pre">datetime</span></code>s are converted to ISO-8601 strings.</p>
<p><code class="xref py py-class docutils literal notranslate"><span class="pre">Enum</span></code>s are converted to their values.</p>
<p><code class="xref py py-class docutils literal notranslate"><span class="pre">UUID</span></code>s are converted to their string equivalents.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Flask’s default JSON encoder converts dates and times using the format
defined in <a class="reference external" href="https://tools.ietf.org/html/rfc822">RFC 822</a>. Since it’s
more common and universal, ISO-8601 has been chosen instead.</p>
</div>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference external" href="https://wikiless.org/wiki/ISO_8601">ISO-8601 Specification</a></p>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="heiwa.json_ld.JSONLDEncoder.default">
<span class="sig-name descname"><span class="pre">default</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">o</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">object</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">Any</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Dict</span><span class="p"><span class="pre">[</span></span><span class="pre">str</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Any</span><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/json_ld.html#JSONLDEncoder.default"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.json_ld.JSONLDEncoder.default" title="Permalink to this definition"></a></dt>
<dd><p>Converts various objects to JSONable values, as described in the
class’ documentation.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>o</strong> – The object to convert.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>A converted version of the object.</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="heiwa.database.utils.html" class="btn btn-neutral float-left" title="Utilities" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="heiwa.enums.html" class="btn btn-neutral float-right" title="Enums" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p></p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>